#include "Decorator.h"

int main(int argc, const char argv[]) {
	std::cout << "Now I want some cakes" << std::endl;
	
	// Then you get a nice cake
	Cake *cake = new Brownie();
	std::cout << cake->getCake() << std::endl;
	std::cout << "I pay " << cake->total() << " for it" << std::endl;
	
	std::cout << std::endl;

	std::cout << "Now I want something more" << std::endl;
	// First you have a bare mousse
	cake = new Mousse();
	std::cout << "I ordered a mousse, I will pay " << cake->total() << std::endl;
	// Then you decorate it with some mount cream
	cake = new MountCream(cake);
	std::cout << "I wanna some cream, which cost " << cake->single() << std::endl;
	std::cout << "After add mount cream I will pay " << cake->total() << std::endl;
	cake = new ChocolateChip(cake);
	std::cout << "I wanna some chocolate chip, which cost " << cake->single() << std::endl;
	std::cout << "After add chocolate chip I will pay " << cake->total() << std::endl;
	std::cout << "At last I have:" << std::endl;
	std::cout << cake->getCake() << std::endl;
	std::cout << "I pay " << cake->total() << " for it" << std::endl;
	return 0;
}